Attribute VB_Name = "Module1"
Option Explicit

Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function RemoveDirectory Lib "kernel32" Alias "RemoveDirectoryA" (ByVal lpPathName As String) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

Private Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

Private Declare Function FindResource Lib "kernel32" Alias "FindResourceA" (ByVal hModule As Long, ByVal lpName As Any, ByVal lpType As Any) As Long
Private Declare Function LoadResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Private Declare Function LockResource Lib "kernel32" (ByVal hResData As Long) As Long
Private Declare Function SizeofResource Lib "kernel32" (ByVal hInstance As Long, ByVal hResInfo As Long) As Long
Private Declare Function FreeResource Lib "kernel32" (ByVal hResData As Long) As Long

Private Declare Function BeginUpdateResource Lib "kernel32.dll" Alias "BeginUpdateResourceA" (ByVal pFileName As String, ByVal bDeleteExistingResources As Long) As Long
Private Declare Function UpdateResource Lib "kernel32.dll" Alias "UpdateResourceA" (ByVal hUpdate As Long, ByVal lpType As Long, ByVal lpName As Long, ByVal wLanguage As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function EndUpdateResource Lib "kernel32.dll" Alias "EndUpdateResourceA" (ByVal hUpdate As Long, ByVal fDiscard As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pTo As Any, uFrom As Any, ByVal lSize As Long)

Private Type BITMAPFILEHEADER
     bfType As Integer
     bfSize As Long
     bfReserved1 As Integer
     bfReserved2 As Integer
     bfOffBits As Long
End Type

Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Private Type Bitmap
   pHeader As BITMAPFILEHEADER
   data() As Byte
End Type

Public sCheminDLL As String
Public sLangID As String

Public Function CheminSystem() As String

   Dim lRet As Long
   
   CheminSystem = Space(255)
   lRet = GetSystemDirectory(CheminSystem, 255)
   CheminSystem = Left$(CheminSystem, lRet)

End Function

Public Function RecupBitmap(sDLL As String, lIndex As Long) As Boolean

   Dim lHandle As Long
   Dim lHRes As Long
   Dim lMem As Long
   Dim lTaille As Long
   Dim lTailleImg As Long
   Dim BMPInfoHeader As BITMAPINFOHEADER
   Dim BMPData As Bitmap
   
   On Error GoTo TantPis
   
   lHandle = LoadLibraryEx(sDLL, 0, &H2)
   lHRes = FindResource(lHandle, lIndex, 2&)
   lMem = LoadResource(lHandle, lHRes)
   lTaille = SizeofResource(lHandle, lHRes)
   
   ReDim BMPData.data(lTaille)
   CopyMemory BMPData.data(0), ByVal LockResource(lMem), lTaille
   CopyMemory BMPInfoHeader, ByVal LockResource(lMem), Len(BMPInfoHeader)
   
   FreeResource lMem
   FreeLibrary lHandle
   
   BMPData.pHeader.bfType = &H4D42
   BMPData.pHeader.bfSize = lTaille + Len(BMPData.pHeader)
   
   If BMPInfoHeader.biSizeImage = 0 Then
      If BMPInfoHeader.biClrUsed Then
         BMPData.pHeader.bfOffBits = Len(BMPData.pHeader) + Len(BMPInfoHeader) + BMPInfoHeader.biClrUsed * 4
      Else
         BMPData.pHeader.bfOffBits = Len(BMPData.pHeader) + Len(BMPInfoHeader) + (2 ^ BMPInfoHeader.biBitCount) * 4
      End If
   Else
      BMPData.pHeader.bfOffBits = lTaille + Len(BMPData.pHeader) - BMPInfoHeader.biSizeImage
   End If

   Open App.Path & "\Temp\" & lIndex & ".bmp" For Binary As #1
      Put #1, 1, BMPData.pHeader
      Put #1, 15, BMPData.data
   Close #1

   RecupBitmap = True
   Exit Function
   
TantPis:
   RecupBitmap = False
   
End Function

Public Function RemplaceImage(sFichier As String, sImage As String, lIndex As Long, lLangID As Long) As Boolean

   Dim lHandle As Long
   Dim lRet As Long
   Dim BMPData As Bitmap
   
   On Error Resume Next
   
   lHandle = BeginUpdateResource(sFichier, 0)
   If lHandle = 0 Then Exit Function
   
   Open sImage For Binary As #1
      Get #1, , BMPData.pHeader
      ReDim BMPData.data(BMPData.pHeader.bfSize - Len(BMPData.pHeader))
      Get #1, Len(BMPData.pHeader) + 1, BMPData.data
   Close #1
   
   If UpdateResource(lHandle, 2&, lIndex, lLangID, ByVal VarPtr(BMPData.data(0)), UBound(BMPData.data)) = 0 Then
      EndUpdateResource lHandle, 1
      Exit Function
   Else
      If EndUpdateResource(lHandle, 0) Then
         RemplaceImage = True
      End If
   End If
   
End Function

Public Sub RemplitScript(sSkin As String)

   On Error Resume Next

   Dim sCh As String

   If Dir(App.Path & "\Original\msgina.dll") = "" Then
      sCh = sCh & vbCrLf & "copy """ & CheminSystem & "\msgina.dll"" """ & App.Path & "\Original\msgina.dll"" /y"
   End If
   
   sCh = sCh & vbCrLf & "del """ & CheminSystem & "\msgina.dll_bak"""
   
   If Dir(Replace(LCase(CheminSystem), "\system32", "") & "\ServicePackFiles\i386", vbDirectory) <> "" Then
      sCh = sCh & vbCrLf & "copy """ & sSkin & "msgina.dll"" """ & Replace(LCase(CheminSystem), "\system32", "") & "\ServicePackFiles\i386\msgina.dll"" /y"
   End If
   sCh = sCh & vbCrLf & "copy """ & sSkin & "msgina.dll"" """ & CheminSystem & "\dllcache\msgina.dll"" /y"
   sCh = sCh & vbCrLf & "rename """ & CheminSystem & "\msgina.dll"" ""msgina.dll_bak"""
   sCh = sCh & vbCrLf & "copy """ & sSkin & "msgina.dll"" """ & CheminSystem & "\msgina.dll"" /y"
   
   If Dir(App.Path & "\Original\shell32.dll") = "" Then
      sCh = sCh & vbCrLf & "copy """ & CheminSystem & "\shell32.dll"" """ & App.Path & "\Original\shell32.dll"" /y"
   End If
   
   sCh = sCh & vbCrLf & "del """ & CheminSystem & "\shell32.dll_bak"""
   
   If Dir(Replace(LCase(CheminSystem), "\system32", "") & "\ServicePackFiles\i386", vbDirectory) <> "" Then
      sCh = sCh & vbCrLf & "copy """ & sSkin & "shell32.dll"" """ & Replace(LCase(CheminSystem), "\system32", "") & "\ServicePackFiles\i386\shell32.dll"" /y"
   End If
   sCh = sCh & vbCrLf & "copy """ & sSkin & "shell32.dll"" """ & CheminSystem & "\dllcache\shell32.dll"" /y"
   sCh = sCh & vbCrLf & "rename """ & CheminSystem & "\shell32.dll"" ""shell32.dll_bak"""
   sCh = sCh & vbCrLf & "copy """ & sSkin & "shell32.dll"" """ & CheminSystem & "\shell32.dll"" /y"
   
   Kill App.Path & "\temp.bat"
   Open App.Path & "\temp.bat" For Binary As #1
      Put #1, , sCh
   Close #1

   ShellExecute Form1.hWnd, "open", App.Path & "\temp.bat", vbNullString, vbNullString, 0

   If MsgBox("Les DLL shell32.dll et msgina.dll sont patches." & vbCrLf & vbCrLf & "Voulez-vous redmarrez maintenant?", vbQuestion Or vbYesNo, "ClmPatch") = vbYes Then
      Shell "shutdown -r -t 0"
      Kill App.Path & "\temp.bat"
      If sSkin <> App.Path & "\Original\" Then
         Kill sSkin & "msgina.dll"
         Kill sSkin & "shell32.dll"
      End If
      Unload Form1
   Else
      Kill App.Path & "\temp.bat"
      If sSkin <> App.Path & "\Original\" Then
         Kill sSkin & "msgina.dll"
         Kill sSkin & "shell32.dll"
      End If
   End If
   
End Sub

Public Sub picTransparente(cPic As PictureBox)

   Dim lTemp As Long
   Dim lSkin As Long
   Dim lDeb As Long
   Dim lY As Long
   Dim lX As Long
   
   On Error Resume Next
   
   DeleteObject cPic.Tag
   lSkin = CreateRectRgn(0, 0, cPic.ScaleWidth, cPic.ScaleHeight)
   
   For lY = 0 To cPic.ScaleHeight - 1
      For lX = 0 To cPic.ScaleWidth - 1
         If GetPixel(cPic.hDC, lX, lY) = vbMagenta Then
            lTemp = CreateRectRgn(lX, lY, lX + 1, lY + 1)
            CombineRgn lSkin, lSkin, lTemp, 4
            DeleteObject lTemp
         End If
      Next
   Next
   
   cPic.Tag = lSkin
   SetWindowRgn cPic.hWnd, lSkin, True
  
End Sub

Public Sub ChargeMiniPic(sFichier As String)

   Form1.imgPrevSkin.Visible = False
   Form1.imgPrevSkin.Picture = Nothing
   Form1.imgPrevSkin.Picture = LoadPicture(sFichier)
   
   If Form1.imgPrevSkin.Picture.Width > Form1.imgPrevSkin.Picture.Height Then
      Form1.imgPrevSkin.Width = Form1.Frame1.Width
      Form1.imgPrevSkin.Left = 0
      Form1.imgPrevSkin.Height = (Form1.Frame1.Width) * Form1.imgPrevSkin.Picture.Height / Form1.imgPrevSkin.Picture.Width
      Form1.imgPrevSkin.Top = ((Form1.Frame1.Height) - Form1.imgPrevSkin.Height) / 2
   Else
      Form1.imgPrevSkin.Height = (Form1.Frame1.Height)
      Form1.imgPrevSkin.Top = 0
      Form1.imgPrevSkin.Width = (Form1.Frame1.Height) * Form1.imgPrevSkin.Picture.Width / Form1.imgPrevSkin.Picture.Height
      Form1.imgPrevSkin.Left = ((Form1.Frame1.Width) - Form1.imgPrevSkin.Width) / 2
   End If

   If Form1.imgPrevSkin.Width > (Form1.Frame1.Width) Then
      Form1.imgPrevSkin.Width = (Form1.Frame1.Width)
      Form1.imgPrevSkin.Left = 0
      Form1.imgPrevSkin.Height = (Form1.Frame1.Width) * Form1.imgPrevSkin.Picture.Height / Form1.imgPrevSkin.Picture.Width
      Form1.imgPrevSkin.Top = ((Form1.Frame1.Height) - Form1.imgPrevSkin.Height) / 2
   End If
   
   If Form1.imgPrevSkin.Height > (Form1.Frame1.Height) Then
      Form1.imgPrevSkin.Height = (Form1.Frame1.Height)
      Form1.imgPrevSkin.Top = 0
      Form1.imgPrevSkin.Width = (Form1.Frame1.Height) * Form1.imgPrevSkin.Picture.Width / Form1.imgPrevSkin.Picture.Height
      Form1.imgPrevSkin.Left = ((Form1.Frame1.Width) - Form1.imgPrevSkin.Width) / 2
   End If

   Form1.imgPrevSkin.Visible = True

End Sub

